/************************************************************************/
/*

	Input class.  Reads blocks of floating point numbers and sends them
	to the analysis class to be sorted.

*/
/************************************************************************/


#include <stdio.h>
#include "rnd.h"

#define NBUF 4

int buf[2];

main() {

	int i;

	int *bp;
	int bufindex;

	int p1,p2,p3;

	FILE *fp,*fopen();

	int eventno = 0;

	float *bcount;

	acp_init();

	fp = fopen("random.numbers","r");
	if (fp == NULL) {
	printf("failed to open input tape\n");
		fflush(stdout);
	acp_stop_job();
	}

	p1 = ACP_ALL_PROCESSES;
	p2 = BEGIN_SYNC;
	acp_sync(&p1,&p2);

	while (1) {

	p1 = EVENT_SIZE*4;
	p2 = NBUF;
	bufindex = acp_buffer_index(buf,&p1,&p2);
	bp = buf;
	bp += bufindex - 1;
	bcount = (float *) bp;

/* Read an event from tape */

	if ((eventno > MAX_EVENTS) || 
		(fread(bp,sizeof(float),EVENT_SIZE,fp) != EVENT_SIZE)) {

		fclose(fp);

		p1 = READY_QUEUE;
		p2 = ACP_FULL;
		acp_wait_queue(&p1,&p2);

		fflush(stdout);
		fflush(stderr);

		p1 = ACP_END_OF_QUEUE;
		p2 = DONE_QUEUE;
		acp_queue_process(&p1,&p2);

		acp_stop_process();

	}
	eventno++;
	if ((eventno % 10) == 0) {
		printf("Event %d read\n",eventno);
		fflush(stdout);
	}
	p1 = EVENT_SIZE*4;
	if (eventno == MAX_EVENTS) p1 /= 2;
	*bcount = (float) p1;	/* Byte count */
	p2 = IN_BLOCK;
	p3 = READY_QUEUE;
	acp_start_send(bp,&p1,&p2,&p3);

	}
}
