/************************************************************************/
/*

    Output class.  Gets blocks of sorted numbers from the analysis class
    and writes them to tape.

*/
/************************************************************************/

#include <stdio.h>
#include "rnd.h"

#define NBUF 3

int eventno = 0;
FILE *outfp;

int write_event(buf,bcount)
int *buf,*bcount;
{
    eventno++;
    if ((eventno % 10) == 0) {
	printf("Event %d written (%d bytes)\n",eventno,*bcount);
    	fflush(stdout);
    }
    fwrite(buf,4,(*bcount)/4,outfp);
}

main() {

    int i,p1,p2,p3,p4,p5;

    FILE *fopen();

    int buf[2];

    acp_init();

    outfp = fopen("sorted.numbers","w");
    if (outfp == NULL) {
	printf("failed to open output tape\n");
	fflush(stdout);
	acp_stop_job();
    }

    p1 = ACP_ALL_PROCESSES;
    p2 = BEGIN_SYNC;
    acp_sync(&p1,&p2);

    while (1) {

	p1 = OUT_SIZE*4;
	p2 = NBUF;
	p3 = OUT_BLOCK;
	p4 = DONE_QUEUE;
	acp_start_gets(buf,&p1,&p2,&p3,&p4);

	p5 = READY_QUEUE;
	acp_handle_data(buf,write_event,&p5);

	p1 = DONE_QUEUE;
	if (acp_end_of_data(buf,&p1)) {
	    acp_stop_job();
	}

	acp_buffer_set_wait(buf);
    }
}
