/************************************************************************/
/*

    Input class.  Reads blocks of floating point numbers and sends them
    to the analysis class to be sorted.

*/
/************************************************************************/


#include <stdio.h>
#include "rnd.h"

#define NBUF 4

main() {

    int i,p1,p2;

    FILE *fp,*fopen();

    int bp = 0;				/* Buffer pointer */
    float x[NBUF][EVENT_SIZE];
    int flag[NBUF];
    int nflag[NBUF];
    int bcount[NBUF];
    int notify[4];
    int qnum;
	int start = 255, end = 256;

    int byte_count,blockno;

    int p;
    int eventno = 0;

    cps_init();

    fp = fopen("random.numbers","r");
    if (fp == NULL) {
	printf("failed to open input tape\n");
    	fflush(stdout);
	cps_stop_job();
    }

    p1 = CPS_ALL_PROCESSES;
    p2 = BEGIN_SYNC;
    cps_sync(&p1,&p2);

    for (i=0; i<NBUF; i++) flag[i] = nflag[i] = -1;
    for (i=0; i<4; i++) notify[i] = -1;

    while (1) {

/* Wait until the next buffer is free (the sleep will be interrupted) */

	while (flag[bp] == 0) sleep(1);
	while (nflag[bp] == 0) sleep(1);

/* Read an event from tape */

	cps_hook( &start );
	if ((eventno >= MAX_EVENTS) || 
	    (fread(&x[bp][0],sizeof(float),EVENT_SIZE,fp) != EVENT_SIZE)) {

		fclose(fp);

    		fp = fopen("random.numbers","r");
    		if (fp == NULL) {
			printf("failed to open input tape\n");
    			fflush(stdout);
			cps_stop_job();
    		}


		continue;

	}
	cps_hook( &end );
	eventno++;
	if ((eventno % 10) == 0) {
	    printf("Event %d read\n",eventno);
	    fflush(stdout);
  	}

/* Queue some data xfers */

	flag[bp] = 0;
	byte_count = EVENT_SIZE * sizeof(float);
	blockno = IN_BLOCK;
	cps_queue_xfer(&x[bp][0],&byte_count,&blockno,&flag[bp],&bcount[bp]);

	nflag[bp] = 0;
	byte_count = 4 * sizeof(int);
	blockno = N_BLOCK;
	cps_queue_xfer(notify,&byte_count,&blockno,&nflag[bp],&bcount[bp]);

/* Do an asynchronous dequeue and send.  The process number returned is
   not used. */

	qnum = READY_QUEUE;
	cps_dq_send(&qnum,&p);

/* Increment the buffer pointer */

	bp++;
	if (bp == NBUF) bp = 0;

    }
}
