#!/bin/sh

machine=`uname`

XLIBS="-lXm -lXt -lX11"
export XLIBS

if [ "$machine" = "IRIX" ]
then
	MAKECPU=SGI
	FORTRAN_COMPILER=f77
	LIBSUN=-lsun
	YPLIB=../yp/libyp.a
	EXTRA_LIBS2=-lrpcsvc
	CCKR=-cckr
	export MAKECPU FORTRAN_COMPILER LIBSUN YPLIB EXTRA_LIBS2 CCKR
elif [ "$machine" = "AIX" ]
then
	MAKECPU=AIX
	FORTRAN_COMPILER=xlf
	EXTRA_LIBS2=-lrpcsvc
	YPLIB=../yp/libyp.a
	export MAKECPU FORTRAN_COMPILER EXTRA_LIBS2 YPLIB
elif [ "$machine" = "HP-UX" ]
then
	MAKECPU=HPUX
	FORTRAN_COMPILER=f77
	EXTRA_LIBS2=-lrpcsvc
	EXTRA_F77=+ppu
	export MAKECPU FORTRAN_COMPILER EXTRA_LIBS2 EXTRA_F77
elif [ "$machine" = "ULTRIX" ]
then
	MAKECPU=ULTRIX
	EXTRA_LIBS1=-ltermcap
	FORTRAN_COMPILER=f77
# Use these switches for DEC FORTRAN V3.0 or earlier
# comment out for V3.1 or later
	EXTRA_F77="-cpp -w"
	export MAKECPU EXTRA_LIBS1 FORTRAN_COMPILER EXTRA_F77
elif [ "$machine" = "SUNOS" ]
then
	MAKECPU=SUNOS
	EXTRA_LIBS=-L/usr/5lib
	EXTRA_LIBS1="-L/usr/5lib -ltermcap"
	EXTRA_LIBS2=-lrpcsvc
	FORTRAN_COMPILER=f77
	export MAKECPU EXTRA_LIBS EXTRA_LIBS1 EXTRA_LIBS2 FORTRAN_COMPILER
elif [ "$machine" = "R3000" ]
then
	MAKECPU=R3000
	EXTRA_LIBS=-lbsd
	FORTRAN_COMPILER=f77
	YPLIB=-lsun
	EXTRA_LIBS2=-lrpcsvc
	export MAKECPU EXTRA_LIBS FORTRAN_COMPILER YPLIB EXTRA_LIBS2
else
	machine=`uname -v`
	if [ "$machine" = "UMIPS" ]
	then
		MAKECPU=MIPS
		EXTRA_LIBS=-lbsd
		EXTRA_LIBS1=-lbsd
		FORTRAN_COMPILER=f77
		YPLIB=-lsun
		EXTRA_LIBS2=-lrpcsvc
		LIBSUN=-lsun
		export MAKECPU EXTRA_LIBS FORTRAN_COMPILER YPLIB EXTRA_LIBS2 \
			EXTRA_LIBS1 LIBSUN
	else
		echo Unknown machine returned by uname
	fi
fi
