/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnsgia.fnal.gov

 Copyright (c) 1990 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/



#define MAX_MSG_LEN 256

struct queue_element {

    char msg[MAX_MSG_LEN];
    struct queue_element *next;

};

struct msg_queue {

    struct queue_element *front;
    struct queue_element *back;
    int len;
    int lock;

};

extern struct msg_queue *create_queue();
extern struct queue_element *remove_q();

struct  io_status_block
{
    unsigned short status;
    unsigned short count;
    unsigned long ipst;    
};

struct send_queue {

    char msg[MAX_MSG_LEN];
    struct io_status_block iosb;
    struct send_queue *next,*prev;  /* Doubly linked list */

};
