/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnsgia.fnal.gov

 Copyright (c) 1990 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/



/* Logical Process Numbering:

	0:										Job Manager
	1 to MAX_PROCESSES:						User Processes
	(MAX_PROCESSES+1) to (2*MAX_PROCESSES):	Shared Memory Processes
	(2*MAX_PROCESSES+1):					PM
*/

#define MAX_PROCESSES 256

#define MAX_SHM_PROCESSES MAX_PROCESSES

#define JM_LPN 0
#define FIRST_USER_LPN 1
#define FIRST_SHM_LPN (MAX_PROCESSES + 1)

#define MAX_CONNECTIONS MAX_PROCESSES

#define MAX_MESSAGE_SIZE 2048
#define SMALL_MSG_SIZE 300

#define MAX_CLASSES 30

#define MAX_QUEUE_NUMBER	127	/* Maximum valid queue number   */
#define MAX_QUEUES (MAX_QUEUE_NUMBER+1)
#define MAX_QUEUE_ARGS 32
#define MAX_QUEUE_BYTES		1024	/* maximum number of bytes in all
					   queue arguments */

#define MAX_SYNC_NUMBER		127	/* Maximum valid sync number	*/
#define MAX_SYNCS (MAX_SYNC_NUMBER+1)

#define MAX_USER_STATUS		4	/* Maximum number of user-defined
					   process status */

#define MAX_SUB_INSTANCES	64

#define MAX_EXPLICIT_MSG	20

#define MAX_USER_HOOKS		128
#define MAX_FUNC_HOOKS		128

#define SHM_FUNC(x) 25
#define S_SHM_FUNC(x) 100

/* cps_mon related parameters */

#define MOP_USER_STATUS 0x1111
#define MOP_INC_CALL 0x2222
#define MOP_STATE_CHANGE 0x3333
#define MOP_Q_PROC 0x4444
#define MOP_DQ_PROC 0x5555
#define MOP_SET_CALL 0x6666

#define MON_USER_STATUS 0
#define MON_CALLS 1
#define MON_STATES 2
#define MON_QUEUES 3
#define MON_TRATES 4		/* Monitor transfer rates */
#define MON_DELTA_CALLS 5
#define MON_DELTA_GRAPH 6

#define INC_CALL 1
#define INC_SEND 3		/* Not monitored yet */
#define INC_GET 4
#define INC_QUEUE 5
#define INC_DEQUEUE 6
#define INC_WAIT_QUEUE 8
#define INC_SYNC 9
#define INC_CALLS_SERV 10

#define PSTATE_RUNNING 1	/* not on any queue */
#define PSTATE_DEAD 2
#define PSTATE_FINISHED 3
#define PSTATE_WAIT_SYNC 4
#define PSTATE_WAIT_QUEUE_FULL 5
#define PSTATE_WAIT_QUEUE_EMPTY 6
#define PSTATE_WAIT_DEQUEUE 7
#define PSTATE_WAIT_CALL 8
#define PSTATE_WAIT_GET 9
#define PSTATE_QUEUED 10
#define PSTATE_WAIT_SERVICE 11	/* Waiting to service call */
#define PSTATE_WAIT_XPL	12	/* Waiting for explicit message */
#define PSTATE_WAIT_SEND 13	/* Waiting for cps_send */
#define PSTATE_WAIT_MOUNT 14	/* Waiting for a tape reply */
#define PSTATE_GET_DONE 15
#define PSTATE_SEND_DONE 16
