/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnsgia.fnal.gov

 Copyright (c) 1990 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/


/********************************/
/* Job Manager Global Variables */
/********************************/

extern char *job_name;
extern char *jdf_file;
extern char *log_file;
extern char *abort_file;
extern char *jm_hostname;
extern long jm_starttime;

extern int batch_mode;
extern char *p_system;

extern int login_prompt;
extern int log_level;
extern int term_level;
extern int dbg_level;

extern int carbon_copy;
extern int invoke_cpp;

extern int pm_connect_flag;

extern int user_timeout;

extern char cpp_options[256];

extern int netrc_exists;
extern char login_name[24];
extern char password[24];

extern char tty_name[64];

extern int rexec_port;

extern FILE *jml;

extern char *msg_cmd,**msg_args;

extern int num_sdf_cpus;
extern struct cpu_info sdf_cpu[MAX_SDF_CPUS];

extern struct class_info class[MAX_CLASSES+1];

extern int num_shm_procs;
extern int num_usr_procs;
extern struct shm_map shm_map[MAX_SHM_PROCESSES];
extern struct user_map usr_map[MAX_PROCESSES];

extern int assigned_port_number;
extern char local_hostname[64];
extern char local_hostaddr[24];

extern struct cps_msg_queue *zfree;
extern struct queue_info jmq[MAX_QUEUES];

extern int sync_active[MAX_SYNCS];
extern unsigned long *need_sync[MAX_SYNCS];
extern unsigned long *at_sync[MAX_SYNCS];
extern int proc_sync[MAX_PROCESSES];

extern int user_status[MAX_PROCESSES][MAX_USER_STATUS];

extern struct acp_remote_sub *remote_subs;
extern struct acp_data_rdy *acp_dblocks[MAX_PROCESSES];

extern int mon_shmid;
extern struct cps_job_stats *mon_shm;

extern char jm_pause;
extern char jm_step;
extern char jm_prof;
extern char jm_init;
extern char sync_stop[ MAX_SYNCS ];
extern char queue_stop[ MAX_QUEUES ];
extern char user_stop[ MAX_USER_HOOKS ];
extern char proc_stop[ MAX_FUNC_HOOKS ];
extern int sync_point;
extern int queue_point;
extern int user_point;
extern int proc_point;
extern char upshot;
extern char jm_hooks;
extern char alarm_occured;
