/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnsgia.fnal.gov

 Copyright (c) 1990 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/


/******************************************************************************/
/* Global variables used to pass information between CPS function calls       */
/******************************************************************************/

extern FILE *acp_fp;
extern int acp_init_called;
extern int acp_local_lpn;
extern int acp_local_class;
extern int acp_local_shm;
extern int acp_shm_lpn;
extern char acp_local_host[64];
extern int acp_set_of_procs;
extern int acp_return_status;
extern char acp_error_info[132];
extern char *acp_fntype;
extern char *acp_func;
extern int acp_local_qnum;
extern int acp_shm_qnum;
extern int num_user_proc;
extern int num_shm_proc;
extern int num_local_proc;
extern int num_semaphores;

/* Shared memory globals */

extern int *acp_nprocs;
extern int *acp_semids;
extern struct procmap *acp_pmap;
extern struct shmmap *acp_smap;
extern cps_message *acp_shmem;
extern cps_msg *acp_sshmem;
extern struct qelem *qelem;
extern int *q_head;
extern int *q_tail;
extern int *q_block;

extern int q_semid;

extern struct acp_data_block *acp_blocks;
extern struct acp_remote_sub *acp_subs;
extern unsigned long *acp_class_proc[MAX_CLASSES+1];
extern unsigned long *acp_static_cp[MAX_CLASSES+1];	/* v2.9 */
extern int acp_request_complete;
extern int acp_dreq_complete;
extern int acp_treq_complete;
extern int acp_sync_complete;
extern int acp_wait_complete;
extern int acp_rsub_complete;
extern int acp_send_complete;
extern int acp_get_complete;
extern int acp_send_aborts;
extern int acp_get_aborts;
extern int acp_return_queue;
extern int acp_queue_declared[MAX_QUEUES];
extern int *acp_queue_bcount[MAX_QUEUES];
extern int acp_queue_bsum[MAX_QUEUES];
extern int acp_qreq_complete;
extern int acp_queue_number;
extern int acp_process_dequeued;
extern char acp_queue_data[MAX_QUEUE_BYTES];
extern struct acp_data_block *acp_remote_blocks[MAX_PROCESSES];

extern struct qelem *acp_q_pop1();
extern struct qelem *acp_q_pop2();
extern struct qelem *acp_q_pop2_no_wait();
extern struct qelem *acp_q_pop3();
extern struct acp_data_block *acp_find_block();
extern struct acp_remote_sub *acp_find_remsub();

extern int mount_reply_status;
extern int mount_reply_pos;
extern int mount_reply_protection;
extern char mount_reply_dev[64];
extern char mount_reply_vsn[32];
extern char mount_reply_msg[132];

extern struct qelem *acp_rms_head;
extern struct qelem *acp_rms_tail;

extern struct acp_msg_queue acp_rms,acp_xpl;
extern int acp_xpl_ready[21];
extern char acp_xpl_msg[MAX_MESSAGE_SIZE+16];

extern struct queued_xfer *acp_qxfer_h;
extern struct queued_xfer *acp_qxfer_t;
extern struct active_qxfer *acp_aqx;
extern int acp_next_qx_id;
extern struct buffer_set *acp_bufset;
extern int acp_num_aborted_xfers;		/* v2.9 */

struct acp_msg_block *acp_dequeue_block();
struct acp_msg_block *acp_checkout_block();

extern int acp_port[MAX_PROCESSES+1];
extern int acp_data_sock[MAX_PROCESSES+1];
extern int acp_dsock;

#define MAX_L_XFERS 32
extern struct direct_xfer acp_r_dxfer[MAX_PROCESSES+1];
extern struct direct_xfer acp_l_dxfer[MAX_PROCESSES+1][MAX_L_XFERS];
extern int acp_dxfer_ptr[MAX_PROCESSES+1];
extern int acp_dxfer_nleft[MAX_PROCESSES+1];

extern char proc_hooks;
extern int acp_hook_complete;
extern char profile;
