/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnfaus.fnal.gov

 Copyright (c) 1991 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/

/*

    Source File: random.c

    Explanation: 

    Exported Routines:


*/

#define SEED 0x79ECA377

static int initialized = 0;

/************************************************************************/
/*

    Function: random_i

    Description:  Generate random integer between l and h inclusive.

    Arguments:

    Function Value:

*/
/************************************************************************/

int random_i(l,h)
int l,h;
{
	double x;
	int i;
	double drand48();
	if (!initialized) {
		srand48(SEED);
		initialized = -1;
	}
	x = drand48() * (double)(h-l+1);
	i = x;
	i += l;
	return i;
}
