
#if defined(SGI) || defined(MIPS) || defined(ULTRIX) || defined(R3000) \
    || defined(HPUX)
#include <stdio.h>
#include <errno.h>
#endif

#ifdef SGI
#include <sys/types.h>
#include <sys/socket.h>
#endif

#ifdef HPUX
#include <sys/types.h>
#include <sys/socket.h>
#endif

#ifdef MIPS
#include <bsd/sys/types.h>
#include <sys/socket.h>
#endif

#ifdef R3000
#include <bsd/sys/types.h>
#include <bsd/sys/socket.h>
#endif

#ifdef SUNOS
#include <sys/types.h>
#include <sys/socket.h>
#endif

#ifdef ULTRIX
#include <sys/types.h>
#include <sys/socket.h>
#endif

#if defined(SGI) || defined(R3000) || defined(MIPS)
#include <sys.s>
#endif

#if defined(ULTRIX) || defined(HPUX)
#include <syscall.h>
#endif

#if defined(SGI) || defined(MIPS) || defined(ULTRIX) || defined(R3000) \
    || defined(HPUX)

int write(fd,buf,cnt)
int fd;
char *buf;
int cnt;
{
	int s;
	do {
		s = syscall(SYS_write,fd,buf,cnt);
	} while ((s <0) && (errno == EINTR));
	return(s);
}

int read(fd,buf,cnt)
int fd;
char *buf;
int cnt;
{
	int s;
	do {
		s = syscall(SYS_read,fd,buf,cnt);
	} while((s < 0) && (errno == EINTR));
	return(s);
}

int open(path,oflag,mode)
char *path;
int oflag,mode;
{
	int s;
	do {
		s = syscall(SYS_open,path,oflag,mode);
	} while ((s < 0) && (errno == EINTR));
	return(s);
}

int close(fildes)
int fildes;
{
	int s;
	do {
		s = syscall(SYS_close,fildes);
	} while ((s < 0) && (errno == EINTR));
	return(s);
}

int accept(sock,addr,addrlen)
int sock;
#if defined(R3000)
struct sockaddr *addr;
#else
void *addr;
#endif
int *addrlen;
{
	int s;
	do {
		s = syscall(SYS_accept,sock,addr,addrlen);
	} while ((s < 0) && (errno == EINTR));
	return(s);
}

int bind(sock,name,namelen)
int sock,namelen;
#if defined(R3000)
struct sockaddr *name;
#else
void *name;
#endif
{
	int s;
	do {
		s = syscall(SYS_bind,sock,name,namelen);
	} while ((s < 0) && (errno == EINTR));
	return(s);
}

int connect(sock,name,namelen)
int sock,namelen;
#if defined(R3000)
struct sockaddr *name;
#else
void *name;
#endif
{
	int s;
	do {
		s = syscall(SYS_connect,sock,name,namelen);
	} while ((s < 0) && (errno == EINTR));
	return(s);
}

int listen(sock,backlog)
int sock,backlog;
{
	int s;
	do {
		s = syscall(SYS_listen,sock,backlog);
	} while ((s < 0) && (errno == EINTR));
	return(s);
}

int recv(sock,buf,len,flags)
int sock,len,flags;
#if defined(R3000)
char *buf;
#else
void *buf;
#endif
{
	int s;
	do {
		s = syscall(SYS_recv,sock,buf,len,flags);
	} while ((s < 0) && (errno == EINTR));
	return(s);
}

int send(sock,buf,len,flags)
int sock,len,flags;
#if defined(R3000)
char *buf;
#else
void *buf;
#endif
{
	int s;
	do {
#if defined(R3000) || defined(MIPS)
        	s = syscall(SYS_write,sock,buf,len);
#else	
        	s = syscall(SYS_send,sock,buf,len,flags);
#endif
	} while ((s < 0) && (errno == EINTR));
	return(s);
}

#endif
