/*
**
** Demo program:
** 
** Prints coefficients of the polynomials
** exp( - x*x ) * d^n / dx^n exp( x*x )
** 
** --- Leo Michelotti
** --- August 31, 1995
**
*/

#include "mxyzptlk.rsc"

main( int argc, char** argv ) {

 if( argc != 2 ) {
  cout << "\nUsage: " << argv[0] << "  n"
       << endl;
  exit(0);
 }

 int n = atoi( argv[1] );

 Jet::Setup( 1, 2*n );
 coord x( 0.0 );
 Jet f, g;
 int d = 1;

 f = exp( - x*x );
 g = f;

 int k = 0;
 cout << "Results for k = " << k << endl;
 ( g / f ).printCoeffs();
 for( k = 1; k <= n; k++ ) {
   g = - g.D( &d );
   cout << "Results for k = " << k << endl;
   ( g / f ).printCoeffs();
 }

}
