/*
**
** Demo program:
** 
** A one-liner: calculates the Lie
** derivative of r**2 under the vector
** field of a damped harmonic oscillator.
** 
** --- Leo Michelotti
** --- August 10, 1993
**
*/

#include <stdlib.h>
#include "mxyzptlk.rsc"

main( int argc, char** argv ) {

 if( argc != 3 ) {
  printf( "\n" );
  printf( "Usage: %s  x  y \n", argv[0] );
  printf( "\n" );
  exit(0);
 }

 Jet::Setup( 2, 1, 2 );

 coord x( atof( argv[1] ) );   
 coord p( atof( argv[2] ) );
 LieOperator v;
 
 v.setVariable(      p, 0 );
 v.setVariable( -x - p, 1 );

 printf( "Answer is: %lf\n", 
         ( v^( x*x + p*p ) ).standardPart() );
}
