/*
**
** Demo program:
** 
** Uses the exponential map method to 
** integrate the harmonic oscillator
** vector field and obtain the linear
** flow map, or more properly, its
** derivatives.
**
** This particular appliation suffers
** from its being a linear vector field,
** so that the derivatives are not 
** calculated exactly.
** 
** --- Leo Michelotti
** --- August 10, 1993
**
*/

#include "mxyzptlk.rsc"

main() {
 Jet::setup( 2, 6, 2 );
 coord x( 0.0 );
 coord y( 0.0 );
 LieOperator v;
 v.setVariable(  y, 0 );
 v.setVariable( -x, 1 );
 v.expMap( 6.2831853072, x ) .printCoeffs();
 v.expMap( 6.2831853072, y ) .printCoeffs();
}
