#include <stdlib.h>
#include <stdio.h>

#define	NUMREG 4

#include "mxyzptlk.rsc"
#include "menu.hxx"

Jet HPreg[ NUMREG ];
Jet xda;

int numberOfVar, topWeight;

main() {

ttMenu menu;

void stvr(),
     rvl(),
     rgop(),
     rith(),
     dffr(),
     nlys(),
     clear(),
     eval();

printf("Enter the number of variables and the max order ..> ");
scanf("%d  %d", &numberOfVar, &topWeight );
getchar();
if( numberOfVar > 6 ) {
  printf("Please .. have mercy!!\n");
  printf("I have reduced the number of variables to 6.\n");
  numberOfVar = 6;
  }
if( topWeight > 12 ) {
  printf("Please .. have mercy!!\n");
  printf("I have reduced the maximum order to 12.\n");
  topWeight = 12;
  }
Jet::setup( numberOfVar, topWeight );

menu.setPrompt( "Jet TEST ..> " );
menu.setItem( "Set variable   ", stvr );
menu.setItem( "Peek           ", rvl  );
menu.setItem( "Register op's  ", rgop );
menu.setItem( "Arithmetic     ", rith );
menu.setItem( "Evaluate       ", eval );
menu.setItem( "Differential of", dffr );
menu.setItem( "Analysis       ", nlys );
menu.setItem( "Clear the stack", clear );
menu.go();
}


void stvr(){
double v;
int i;

for( i = NUMREG-1; i > 0; i-- ) HPreg[i] = HPreg[i-1];

printf("Enter the value of the new term ..>  ");
scanf( "%lf", &v );
getchar();
printf("Enter one integer corresponding to the index ..>  ");
scanf( "%d", &i );
getchar();

HPreg[0].setVariable( v, i );

for( i = 0; i < NUMREG; i++ ) HPreg[i].fixReference();
}

void rvl(){
int j = 5;
while( ( j < 0 ) || ( j > NUMREG ) ) {
  printf("Which register?? ..>  ");
  scanf( "%d", &j );
  getchar();
  }
HPreg[j].peekAt();
}

void rgop() {
ttMenu rgopMenu;
void entr(),
     xy(),
     rdown();
rgopMenu.setPrompt( "Reg Ops ..> " );
rgopMenu.setItem( "Set variable   ", stvr  );
rgopMenu.setItem( "Peek           ", rvl   );
rgopMenu.setItem( "Enter          ", entr  );
rgopMenu.setItem( "Interchange    ", xy    );
rgopMenu.setItem( "Rotate         ", rdown );
rgopMenu.go();
}

void rith() {
ttMenu rithMenu;
void neg(),
     plus(),
     minus(),
     mltp(),
     dvd();
rithMenu.setPrompt( "Arithmetic ..> " );
rithMenu.setItem( "Negate         ", neg  );
rithMenu.setItem( "Add            ", plus );
rithMenu.setItem( "Subtract       ", minus );
rithMenu.setItem( "Multiply       ", mltp );
rithMenu.setItem( "Divide         ", dvd  );
rithMenu.go();
}

void eval() {
int i;
double* z;

z = new double[ numberOfVar ];

printf( "Enter %d real numbers ..> ", numberOfVar );
for( i = 0; i < numberOfVar; i++ ) scanf( "%lf ", z+i );
getchar();
printf( "Confirming: You have entered  " );
for( i = 0; i < numberOfVar; i++ ) printf( "%lf ", z[i] );
printf("\n");

getchar();

printf( "\nThe value is %lf.\n", HPreg[0](z)  );

delete z;
}

void dffr() {
int r;
JLterm* p;
printf("Enter the register ..> ");
scanf( "%d", &r );
p = HPreg[r].get();
}

void nlys() {

ttMenu nlysMenu;

void drvt(),
     fltr(),
     xpon(),
     ssnn(),
     ccss(),
     ssqq(),
     llgg();

nlysMenu.setPrompt( "Analysis ..> " );
nlysMenu.setItem( "differentiate  ", drvt );
nlysMenu.setItem( "filter         ", fltr );
nlysMenu.setItem( "exp()          ", xpon );
nlysMenu.setItem( "sin            ", ssnn );
nlysMenu.setItem( "cos            ", ccss );
nlysMenu.setItem( "sqrt           ", ssqq );
nlysMenu.setItem( "log            ", llgg );
nlysMenu.go();

}

void clear() {
int i;
for( i = 0; i < NUMREG; i++ ) HPreg[i].setVariable( 1.0, -3 );
}


void neg(){
Jet dummy;
dummy = HPreg[0];
HPreg[0] = - dummy;
}

void plus() {
int i;
HPreg[0] += HPreg[1];
for( i = 1; i < NUMREG - 1; i++ ) HPreg[i] = HPreg[i+1];
}

void minus() {
int i;
HPreg[0] = HPreg[1] - HPreg[0];
for( i = 1; i < NUMREG - 1; i++ ) HPreg[i] = HPreg[i+1];
}

void mltp() {
int i;
HPreg[0] = HPreg[1]*HPreg[0];
for( i = 1; i < NUMREG - 1; i++ ) HPreg[i] = HPreg[i+1];
}

void dvd() {
int i;
HPreg[0] = HPreg[1]/HPreg[0];
for( i = 1; i < NUMREG - 1; i++ ) HPreg[i] = HPreg[i+1];
}


void fltr() {
int source, sink, weightLo, weightHi;
printf("Enter source register ..>  ");
scanf( "%d", &source );
getchar();
printf("Enter sink register ..>  ");
scanf( "%d", &sink );
getchar();
printf("Enter desired weight range ..>  ");
scanf( "%d %d", &weightLo, &weightHi );
getchar();
HPreg[ sink ] = HPreg[ source ].filter( weightLo, weightHi );
}

void xpon() {
HPreg[0] = exp( HPreg[0] );
}

void ssnn() {
HPreg[0] = sin( HPreg[0] );
}

void ccss() {
HPreg[0] = cos( HPreg[0] );
}

void ssqq() {
HPreg[0] = sqrt( HPreg[0] );
}

void llgg() {
HPreg[0] = log( HPreg[0] );
}

void drvt() {
int i;
int* n;

n = new int[ numberOfVar ];

printf( "Enter %d integers for the index set ..> ", numberOfVar );
for( i = 0; i < numberOfVar; i++ ) scanf( "%d", n+i );
getchar();
printf( "Confirming: You have entered  " );
for( i = 0; i < numberOfVar; i++ ) printf( "%d ", n[i] );
printf("\n");

HPreg[0] = HPreg[0].D( n );
}


void entr() {
int i;
for( i = NUMREG - 1; i > 0; i-- ) {
  HPreg[i] = HPreg[i-1];
  }
}

void xy() {
Jet z;
z = HPreg[1];
HPreg[1] = HPreg[0];
HPreg[0] = z;
}

void rdown() {
Jet z;
int i;
z = HPreg[0];
for( i = 0; i < NUMREG - 1; i++ ) HPreg[i] = HPreg[i+1];
HPreg[NUMREG] = z;
}

