// This is written only to avoid constant warning messages
// about ambiguous operators.  It arises because of constructors
// which can change double and complex to matrices or jets.
// 
// Leo Michelotti
// Dec 16, 1994    (Battle of the Bulge + 50 years)

#ifndef COMPLEXADDON_HXX
#define COMPLEXADDON_HXX

inline complex operator+( const complex& x, const double& y )
{
 return x + (complex) y;
}

inline complex operator+( const double& x,  const complex& y )
{
 return (complex) x + y;
}

inline complex operator-( const complex& x, const double&  y )
{
 return x - (complex) y;
}

inline complex operator-( const double& x,  const complex& y )
{
 return (complex) x - y;
}

inline complex operator*( const complex& x, const double& y )
{
 return x * (complex) y;
}

inline complex operator*( const double& x,  const complex& y )
{
 return (complex) x * y;
}

inline complex operator/( const complex& x, const double& y )
{
 return x / (complex) y;
}

inline complex operator/( const double& x,  const complex& y )
{
 return (complex) x / y;
}

inline double fabs( const complex& x )
{
 return abs(x);
}

#endif
